(compiletime (put 'putword 'PASS-1-MACRO 'pa1m-putword))



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         CONVEX-LAP.SL
% Description:
% Author:
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1988, Konrad Zuse Zentrum Berlin
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(compiletime(progn
(put 'reloc_word          'const 1)
(put 'reloc_id_number     'const 2)
(put 'escape_to_second    'const 3)
(put 'parcel_label        'const 0)
(put 'word_label          'const 1)
(put 'reloc_value_cell    'const 2)
(put 'reloc_function_cell 'const 3)
nil))
 
(fluid '(labeloffsets* currentoffset* codesize* codebase* entries*
         forwardinternalreferences*
         newbittableentry* lapreturnvalue*
         *nextbit* NAlloc*
         *writingfaslfile initoffset* *pgwd *pwrds
         lapcodelist* *GenerateCode))
 
%/ Initially work in parcel address, but may need to keep
%/ both word and parcel attribute
 
(commentoutcode
(flag '(saveentry defineentries depositinstruction
       opcodevalue operandvalue depositword depositwordexpression
       deposithalfwords labelvalue deposititem deposithalfwordidnumber
       findlabels onelaplength makerelocinf makerelocword)
     'internalfunction))
 
% (compiletime (flag '(adjustlabels) 'internalfunction))
 
(de labelp (x) (or (idp x) (stringp x) (eqcar x 'label)))
 
(de shortlabelp (x) (labelp x))
 
(de shortlabelval(x) 
      % compute offset for a branch instruction
       (wquotient (wdifference (labeloffset x) currentoffset*) 2))

(de forceup (p)
 % Get Parcel address to next word (byte addr = multiple of 4)
 (wshift (wshift (wplus2 p 3) -2) 2 ))
 
(de forcedown (p) (wshift (wshift p -2) 2 ))
 
% New verison of lap that checks for the presence of any *link cmacros.
(fluid '(&links-present&))
 
(de lap (u)
  (prog (lapreturnvalue* labeloffsets* entries* adjusted gaplength)
    (when (getd 'lapopt) (setq u (lapopt u)))
    (setq *generateCode T)
    (cond ((not *writingfaslfile) (setq currentoffset* 0))
          (t (while (not (wordboundaryp currentoffset*))
             (progn
             % Set the bit table to ignore the parcels.
              (updatebittable 1 0)
              (setq currentoffset* (wplus2 currentoffset* 1))))))
%   (setf &links-present& (or (look-for-links u)
%     (assoc '*lambind u) (assoc '*progbind u)
%     (assoc '*Id-apply u)
%     (assoc '*call u)))
    (setq u (&fillframeholes u))
    (setq u (pass1lap u))
    (when (getd 'lapopt2) (setq u (lapopt2 u)))
    (setq u (findlabels u))
    (setq u (optimizebranches u))
    (when *pgwd  (terpri) (terpri))
    (cond (*pgwd
         (foreach x in u do
                (cond ((atom x) (prin2 x))
                    (t (printf "            %p%n" x))))))
    (when *pgwd  (terpri) (terpri))
    (when (not *writingfaslfile)
          (setq codebase* (gtbps (wquotient (forceup codesize*) 4))))
    % Need to work in PARCELS, GtBPS in WORDS
    (cond (*pgwd
         (prog (outputbase*)
           (setq outputbase* 16)
           (printf "%nBegining Code Base = %p%n" 
                   (plus codebase* currentoffset*) ))))
 
    (foreach x in u do
           (cond ((not (labelp x))
                (cond ((equal (first x) '*entry) (saveentry x))
                      (t (depositinstruction x))))))
    (defineentries)
    (cond ((and (not *writingfaslfile) *pwrds)
         (errorprintf "*** %p: base %o, length %d bytes"
                  (foreach x in entries* collect (first (car x)))
                   codebase*  (forceup codesize*) )))
    (cond (lapreturnvalue*
         (return (mkcode lapreturnvalue* ))))))     % MKcode in bytes
 
 
%(de look-for-links (u)
%      (cond ((null u) nil)
%            ((atom (car u)) (look-for-links (cdr u)))
%            ((eq (caar u) '*link)
%                 (cond
%                   ((eq  (cadar u) 'catchsetup) t) % is opencode
%                        % but problems will arise in throw if no
%                        % allocation takes place
%                   ((get (cadar u) 'opencode) (look-for-links (cdr u)))
%                   (t t)))
%            (t (look-for-links (cdr u)))
%)      )
 
 
(de saveentry (x)
  (cond ((equal (second x) '***code**pointer***)
       (setq lapreturnvalue*           % Magic token that tells LAP to return
         (cond (*writingfaslfile currentoffset*)
             (t       %  a code pointer
              (wplus2 codebase* currentoffset*)))))
      ((not *writingfaslfile)
       (progn
        (setq entries* (cons (cons (rest x) currentoffset*) entries*))
        (cond ((not lapreturnvalue*)
             (setq lapreturnvalue*
               (wplus2 codebase* currentoffset*))))))
      ((equal (second x) '**fasl**initcode**)
       (setq initoffset* currentoffset*))
      ((flagp (second x) 'internalfunction)
       (put (second x) 'internalentryoffset currentoffset*))
      (t (progn
          (findidnumber (second x))
          (dfprintfasl (list 'putentry (mkquote (second x))
                         (mkquote (third x))
                         currentoffset*))))))
 
(de defineentries nil
    (foreach x in entries* do
      (putd (first (car x))
            (second (car x))
            (mkcode  (wplus2 codebase* (cdr x)) ))))
 
(de depositinstruction (x)
  %
  % Legal forms are:
  %  (special_form . any)
  %
  (prog (y)
    (return
     (cond ((setq y (get (first x) 'instructiondepositfunction))
              (apply y (list x)))
           ((setq y (get (first x) 'opcodefunction))
              (opcodeapply y (cdr x)))
           ((setq y (get (first x) 'opcodefexprfunction))
              (apply y (list (cdr x))))
           (t (stderror (bldmsg "%p is not a legal OP form%n" x)))))))
 
(de opcodeapply (fn pars)
    (if (wlessp (length pars) 3)
        (opcodeapply fn (append pars (list 'DUMMY)))
        (apply fn pars)))
 
 
(de depositwordblock (x)
    (foreach y in (cdr x) do (depositwordexpression y))) 
 
(put 'fullword 'instructiondepositfunction 'depositwordblock)
 
(de DepositString (X)                   % (STRING "xxxxxx")
(prog (s)
    (setq X (second X))
    (setq s (Size X))
    (for (from I 0 S 1) (do (DepositByte (Indx X I))))
    (DepositByte 0)
    (setq s (wplus2 s 2))
    (while (not (equal (Remainder s 4) 0))
           (DepositByte 0)
           (setq s (iadd1 s)))))

 
(put 'string 'instructiondepositfunction 'depositstring)
 
(de depositfloat (x)                    % this will not work in cross-assembly
(progn (setq x (inf (second x)))
  % (depositword  1)                          % header word
    (depositword (floathighorder x))
    (depositword  (floatloworder x))))
 
(put 'float 'instructiondepositfunction 'depositfloat)
 
(de wordboundaryp (x) (equal (lapland x 3) 0))
 
% (de halfwordboundaryp (x)  (equal (lapland x 1) 0))
 
 
(de labelvalue (u)
  (prog (v)
    (return
     (cond ((codep u) (inf u))
         ((setq v (assoc u labeloffsets*))
          (progn (setq v (cdr v))
               (cond (*writingfaslfile v)
                   (t (wplus2 codebase* v)))))
         (t (stderror (bldmsg "Unknown label %r in LAP" u)))))))
 
(de labeloffset (l)
  (let (offset)
    (cond
     ((codep l) (if *writingfaslfile
                  (inf l)
                  (wdifference (inf l) codebase*)))
     ((setq offset  (atsoc l labeloffsets*)) (cdr offset))
     (t (stderror (bldmsg "Unknown label %r among %w" l labeloffsets*)))
     )))
 

 
 
% Purpose is to resolve any internal references.  The
% forwardinternalreferences* variable contains an offset and a name of
% an id that needs to be fixed up.

(de systemfaslfixup ()
  (prog (x type label place fwdir )
        (while forwardinternalreferences*
          (setq fwdir (pop forwardinternalreferences*))
          (setq label (car fwdir) 
                place (cdr fwdir))
          (if (null (setq x (get label 'internalentryoffset)))
            (errorprintf "*** %r not defined in this module, call is incorrect"
                         label)
            (putword (wplus2 codebase* place) 0 x)))
        (mapobl (function (lambda (y) (remprop y 'internalentryoffset))))
))

% Kludge since the cross assembler can't handle internal functions.
(de reminternalentryoffset (x)
 (remprop x 'internalentryoffset))
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% PASS1 LABEL stuff
% Increment Codesize!* by size of each instruc, define lables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
(de findlabels (lapcodelist*)
     (let (n)
         (setq codesize* 0)
         (foreach x in lapcodelist* collect
             (progn (setq n (onelaplength x))
                    (setq codesize* (wplus2 codesize* n)))
                    (cons n x))
   ))
 
(de onelaplength (u)
% determine size of each instruc
  (prog (x)
    (return
     (cond
      ((atom u)
       (setq labeloffsets*
        (cons (cons u (wplus2 currentoffset* codesize*))
            labeloffsets*)) 0)
      ((eqcar u '*entry) 
         (push (cons (cadr u) (wplus2 currentoffset* codesize*)) 
               labeloffsets*) 
       0)
      ((setq x (get (car u) 'laplength))
       (cond ((posintp x) x) (t (apply x (list u)))))
      ((setq x (get (car u) 'OpLengthFunction))
       (opcodeapply x (cdr u)))
      (t
       % minor klugde for long constants
       %/ Doesnt seem needed for CONVEX
       (progn
      (cond
       ((and (equal (length u) 3) (fixnp (setq x (third u)))
             (not (immediatep x)))
        (prog (y)
          (rplaca (rest (rest u)) (setq y (stringgensym)))
          (nconc lapcodelist* (list y (list 'fullword x))))))
      2))))))
 
(fluid '(jumps*))

(setq jumps*
    '((jmps!.t . brs!.t) (jmps!.f . brs!.f)(jmpa!.t . bra!.t) (jmpa!.f . bra!.f)
      (jmp .  br)))

(de optimizebranches(u)
      (prog (r i x targ n l jumpon)
         (setq n currentoffset*)
         (while u
              (setq i (pop u))
              (setq l (pop i))
              (when (and (not jumpon)
                         (pairp i)
                         (setq x (atsoc (car i) jumps*))
                         (labelp (cadr i))
                         (setq targ (assoc (cadr i) labeloffsets*))
                         targ
                         (setq targ (cdr targ))
                         (lessp (abs(wdifference n targ)) 255)
                           %protect jump table from JUMPON
                         (or (null u)
                             (atom (cdar u))
                             (not (setq jumpon 
                                    (memq (cadr (car u)) '(JMP BR)))))
                             
                    )
                     (setq i (cons (cdr x) (cdr i)))
                     (adjustlabels n)
                     (setq l 2)
             )
             (setq n (wplus2 n l))
             (push i r))
         (return (reversip r))))
 
(de adjustlabels (n)
    (setq codesize!* (difference codesize!* 4))
    (setq labeloffsets* 
        (foreach x in labeloffsets* collect
            (if (wgreaterp (cdr x) n)
                (cons (car x) (wdifference (cdr x) 4))
                x))))

(deflist '((*entry   lapentrylength)
           (float    8)
           (string   lapstringlength)
           (fullword lapwordlength)
    %      (halfword laphalfwordlength)
           (byte     lapbytelength)) 'laplength)
 
(de forceupoffset (u) u)

(de lapentrylength (u)
% Make a label for each (!*ENTRY name type nargs)
(progn (setq codesize* (forceupoffset codesize*))       % Start proc
   (setq labeloffsets* (cons
                  (cons (second u) (wplus2 currentoffset* codesize*))
                                   labeloffsets*)) 0))
 
(de lapstringlength (u)
(progn (setq codesize* (forceupoffset codesize*))
   (wtimes2 4 (strpack (strlen (strinf (second u)))))))
 
(de lapwordlength (u)
(progn (setq codesize* (forceupoffset codesize*))
    (wtimes2 4 (length (rest u)))))
 
%(de laphalfwordlength (u)
%(progn (setq codesize* (forceupoffset codesize*))
%    (times 4 (laplsh (lapadd1 (length (rest u))) -1))))
 
 
(de lapbytelength (u)
(progn (setq codesize* (forceupoffset codesize*))
    (wtimes2 4 (strpack (length (rest u))))))
 
% ExtraRegLocation is in CONVEX-FORMS
 
(put 'extrareg 'operandvaluefunction 'extrareglocation)
 
