%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXC:COMPILER.SL
% Description:  PSL Compiler.
% Author:       Harold Carr & Leigh Stoller
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% This file loads in all the compiler modules for 370.
%


(load datamachine
      sys-consts
      pass-1
      pass-2-3
      comp-decls
      xa-operand
      pass-1-lap
      xa-lap xa-instrs xa-cmacs xa-comp xa-format xa-ldep faslout xa-spec)

(setq *writingfaslfile nil)
(setq *writingasmfile nil)
(remprop 'wquotient 'openfn)
(remprop 'wtimes2 'openfn)

(defcmacro *ALLOC
        ((Freep) (using "*" (reg r15)))
        (       (STM (Reg r11)(reg r15) (displacement (reg r13) 52))
                (*move (plus2 80 ArgOne) (reg r0))
                (LR (reg r12) (reg r13))
		(stm (Reg r2) (reg r3)  (displacement (reg st) 16))
                (SLR (reg r13) (reg r0))
                (st  (reg r12)  (displacement (reg r13) 4))
                (Balr (reg r3) (reg r0))
                (Using "*" (reg r3) (reg r2))
% will be optimized after pass-1-lap phase
                (la (reg r2) (displacement (reg r3) 2048))
                (la (reg r2) (displacement (reg r2) 2048))))

(DefCMacro *DeAlloc
         ((FreeP))
         (     (L  (reg r13) (displacement (reg r13) 4))
                (LM (reg r2) (reg r3) (displacement (reg r13) 16))
                (LM (reg r12) (reg r14) (displacement (reg r13) 56))))

(de *LinkE (DeAllocCount FunctionName FunctionType NumberOfArguments)
  (if (FlagP FunctionName 'ForeignFunction)
        (list (list '*ForeignLink FunctionName FunctionType NumberOfArguments)
          '(*Exit 0))
      (if (get functionname 'exitopencode)
              `((L (REG T2) (LIT (FULLWORD (idoffset SYMFNC))))
                (L (REG T2) (LIT (FULLWORD (VALUECELL ($FLUID SYMFNC)))))
                (L (REG T2) (DISPLACEMENT (REG T2) 0))
                (*DeAlloc ,DeAllocCount)
                (*JCall ,FunctionName))
      (if (get functionname 'opencode)
              `((*Call ,FunctionName)
                (*exit ,DeAllocCount))
      (if (InternallyCallableP FunctionName)
        `((l (reg r15) (lit (fullword (InternalEntry ,FunctionName))))
          (*DeAlloc ,DeAllocCount)
          (br (reg r15)))
       (if (asmp)
        `((L   (reg r0) (lit "    DC   V(SYMFNC)"))
          (*DeAlloc ,DeAllocCount)
	  (LR (reg t1) (reg r0))
          (*JCall ,FunctionName))
        `((L (reg t2) (lit (fullword (idoffset ,FunctionName))))
          (L   (reg r15) (lit (fullword (entry ,FunctionName))))
          (*DeAlloc ,DeAllocCount)
          (L   (reg r15) (indexed (reg r15) 0))
          (BR  (reg r15) ))))))))

% End of file.
