%      Lap Code optimizers

(compiletime (load if-system))
(compiletime (progn (load useful) (on fast-integers)))

(fluid '(!*lapopt))
 
(de lapopt2 (u)
   % lapopt for instructions
    (prog()
        (when (not *lapopt) (return u))
     (when (or (eq *lapopt t)
                  (and (numberp *lapopt)
                       (not (izerop (wand *lapopt 4)))))
              (setq u (lapoptreformloads u)))
        (return u)))
     
(setq !*lapopt t)

(when (null (getd 'myLapoptFrame))
      (copyd 'myLapoptFrame 'LapoptFrame))

(de LapoptFrame(u)(lapopt2 (myLapoptFrame u)))

%%----------------------------------------------------------------- 
 
%----------------------------------------------------------------------
 
(fluid '(jumps*))
 
(setq jumps* '(ja jae jael jb jbe jbel jcxz je jecxz jel
               jg jgel jgl jl jle jlel jll jmp jmpl 
               jna jnae jnael jnal jnb jnbe jnbel jnbl
               jne jnel jng jnge jngel jngl jnl
               jnle jnlel jnll jno jnol jnp jnpl jnps
               jns jnsl jnsz jnzl jo jol jp jpe
               jpel jpl jpo jpol js jsl jz jzl
               call *entry ret))

(compiletime (ds target(x)(caddr x)))

(de LapOptReformLoads (code)
  (let (rcode rrcode inst0 inst2 x y z inst1)
    (while code
      (setq inst0 (pop code))
      (when (and (pairp inst0) 
               rcode 
               (isaload? (setq inst1 (car rcode)))
               (member (target inst1) (operands inst0)))
            (cond((and % previous instruction available?
		    (cdr rcode) 
		    (pairp (setq inst2 (cadr rcode)))
                    (not (isaload? inst2))
                    (not (isastore? inst2))
                    (not (isajump? inst2))
                        % independent?
		    (not (member (target inst1) (operands inst2)))
                    (not (member (target inst2) (operands inst1)))
                  )
                     (prin2 "`")
	             (setq x (pop rcode)) (setq y (pop rcode))
		     (push x rcode) (push y rcode))
                 ((and % next instruction available?
 		     code
		    (pairp (setq inst2 (car code)))
                    (not (isaload? inst2))
                    (not (isastore? inst2))
                    (not (isajump? inst2))
                        % independent?
                    (not (member (target inst1) (operands inst2)))
                    (not (member (target inst2) (operands inst1)))
                  )
                  (prin2 "'")
                  (setq x (pop code))
                  (push inst0 code)
                  (setq inst0 x))))

	(push inst0 rcode))

      (reversip rcode) 
  ))

(de isaload?(inst1)
         (and (eqcar inst1 'MOV)
              (pairp (cadr inst1))
              (memq (caadr inst1)  
                    '(displacement indirect $fluid fluid global $global))))

(de isastore?(inst1)
       (or
         (eqcar inst1 'PUSH)
         (and (eqcar inst1 'MOV)
              (pairp (caddr inst1))
              (memq (caaddr inst1)
                    '(displacement indirect $fluid fluid global $global)))))

(de isajump?(inst1) (memq (car inst1) jumps*))

(de operands (x)	 %simplified form , only looking for regs
   % extract the operands from x
   (cond ((atom x) nil)
	 ((or (memq (car x) '(reg))) (list x))
         ((memq (car x) '(displacement indexed indirect))
          (operands (cdr x)))
         (t (nconc (operands (car x)) (operands (cdr x))))))


