%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PXNK:APPLY-LAP.SL
% Title:          LAP support for EVAL and APPLY  (Hacked version for testing)
% Author:         Eric Benson
% Created:        20 August 1981
% Modified:       26 Jan 1984 1040-PST (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
% Package:        Kernel
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Sep-88 (Julian Padget)
%  Bnd... declarations changed from fluid to global.
% 26 Jan 1984 1036-PST (Brian Beach)
%  Corrected file name in header.
% 2-Dec-83  16:00:00 (Brian Beach)
%   Translated from Rlisp to Lisp.
% Griss and Perdue, 10 January 1983
%	Modified Undefined function to make compiled calls
%	continuable
%
% may 23-1988 chris burdorf and T. Yamamoto
%   modified for sparc, got rid of vax specific code in casel, extv, 
%   autoincrement, and divl
%
% July 20,1988 T. Yamamoto: inline coding of argument distribution.
% November15 1988 W. Neun, removed move and *move (frame  ) cmacros
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(global '(bndstkptr bndstkupperbound))

(compiletime (load sys-macros))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CodeApply(CodePtr, ArgList);
% begin scalar N;
%     N := 0;
%     while PairP ArgList do
%     <<  N := N + 1;
%	  ArgumentRegister[N] := car ArgList;
%	  ArgList := cdr ArgList >>;
%     (jump to address of code pointer)
% end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(lap '((*entry codeapply expr 2)
       %
       % CodeApply(CodePointer, ArgList)
       %
       % (reg 1) is code pointer
       % (reg 2) is arg list
       %
       (*alloc 0)
       (*move (reg argone) (reg t6))
       (depi 8 4 5 (reg t6))			% (reg t1) <- entry point.
       (*move (reg argtwo) (reg t2))		% (reg t2) <- arglist

       (*jumpeq (label CONTINUE) (reg t2) (reg nil))	% 0 argument

       (*move (car (reg t2)) (reg 1))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 2))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 3))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 4))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 5))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 6))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 7))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 8))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 9))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 10))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 11))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 12))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 13))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 14))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 15))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 16))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (quote "Too many arguments to function") (reg 1))
       (*dealloc 0)
       (*jcall stderror)
       
CONTINUE
       (*dealloc 0)
       (bv (displacement2 (reg t6) (reg r0)))
       (nop)))
       

(de codeevalapply (codeptr arglist)
  (codeapply codeptr (evlis arglist)))

(de bindeval (formals args)
  (bindevalaux formals args 0))

(de bindevalaux (formals args n)
  (let (f
        a)
       (cond ((pairp formals) (if (pairp args)
                (progn (setq f (first formals))
                       (setq a (eval (first args)))
                       (setq n
                        (bindevalaux (rest formals) (rest args) (iadd1 n)))
                       (if (weq n -1)
                         -1
                         (progn (lbind1 f a)
                                n)))
                -1))
             ((pairp args) -1)
             (t n))))

(lap '((*entry undefinedfunctionaux expr 0)
       %
       (*alloc 17)
       (*wplus2 (reg t2) 8000)
       (*move (reg t2) (frame 1))   % Set continueable address
       (*move (reg 1)(frame 2))
                                % Save all the regs (including fakes) (args)
       (*move (reg 2)(frame 3))
       (*move (reg 3)(frame 4))
       (*move (reg 4)(frame 5))
       (*move (reg 5)(frame 6))
       (*move (reg 6)(frame 7))
       (*move (reg 7)(frame 8))
       (*move (reg 8)(frame 9))
       (*move (reg 9)(frame 10))
       (*move (reg 10)(frame 11))
       (*move (reg 11)(frame 12))
       (*move (reg 12)(frame 13))
       (*move (reg 13)(frame 14))
       (*move (reg 14)(frame 15))
       (*move (reg 15)(frame 16))
       (*move (reg 16)(frame 17))

       (*move (frame 1) (reg 2))
       (*mkitem (reg 2) (wconst id-tag))
       (*move (reg 2) (frame 1))
       (*move '"Undefined function %r called from compiled code" (reg 1))
       (*call bldmsg)
       (*move (reg 1) (reg 2))
       (*move (wconst 0) (reg 1))
       (*move (reg nil) (reg 3))
       (*call continuableerror)

       (*move (frame 17 ) (reg 16))  
                          % Restore all those possible arguments
       (*move (frame 16 ) (reg 15))
       (*move (frame 15 ) (reg 14))
       (*move (frame 14 ) (reg 13))
       (*move (frame 13 ) (reg 12))
       (*move (frame 12 ) (reg 11))
       (*move (frame 11 ) (reg 10))
       (*move (frame 10 ) (reg 9))
       (*move (frame 9 ) (reg 8))
       (*move (frame 8 ) (reg 7))
       (*move (frame 7 ) (reg 6))
       (*move (frame 6 ) (reg 5))
       (*move (frame 5 ) (reg 4))
       (*move (frame 4 ) (reg 3))
       (*move (frame 3 ) (reg 2))
       (*move (frame 2 ) (reg 1))
       (*move (frame 1) (reg t1))
       (*linke 17 fastapply)))

%
% This is pretty gross, but it is essentially the same as LambdaApply, taking
% values from the argument registers instead of a list.
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CompiledCallingInterpreted IDOfFunction;
% begin scalar LForm, LArgs, N, Result;
%     LForm := get(IDOfFunction, '!*LambdaLink);
%     LArgs := cadr LForm;
%     LForm := cddr LForm;
%     N := 1;
%     while PairP LArgs do
%     <<  LBind1(car LArgs, ArgumentRegister[N];
%         LArgs := cdr LArgs;
%         N := N + 1 >>;
%     Result := EvProgN LForm;
%     UnBindN(N - 1);
%     return Result;
% end;

(lap '((*entry compiledcallinginterpretedaux expr 0) 
       % link for lambda
       %
       %
       (*wplus2 (reg t2) 8000)
       (*move (reg t2) (reg t3))
       (*mkitem (reg t3) (wconst btr-tag))        % make stack mark for btrace

       (*field (reg t1) (reg t2) 5 27)
       (*wshift (reg t1) 2)
       (*wplus2 (reg t1) ($fluid symprp))         % Prop list address
       (*move (memory (reg t1) (wconst 0))        % Property list
              (reg t1))
LOOPFINDPROP
       (*jumpnottype (label propnotfound) (reg t1) pair-tag)
                                           % make sure prop list is a pair
       (*move (car (reg t1)) (reg t2))     % get car of prop list
       (*move (cdr (reg t1)) (reg t1))     % cdr down
       (*jumpnottype (label LOOPFINDPROP) (reg t2)  pair-tag)
       (*move (car (reg t2)) (reg t3))     % yes, look at car
       (*move (quote *lambdalink) (reg t4))
       (*jumpnoteq (label loopfindprop) (reg t3) (reg t4))
       (*move (cdr (reg t2)) (reg t1))     % yes, get lambda form
       (*jcall fastlambdaapply)
%
%	At this point, (reg t1) <- lambda function to be called.
%
(*entry fastapply expr 0)
 
       % Apply with arguments loaded
       %
       % Called with arguments in the registers and functional form in t1.
 
       (*field (reg t2)                    % Tag of function into T2
               (reg t1)
               (wconst tagstartingbit)
               (wconst tagbitlength))
       (*field (reg t1)                    % Inf of function into T1
               (reg t1) 
               (wconst infstartingbit)
               (wconst infbitlength))
 
       (*move (reg t1) (reg t6))
       (*jumpnoteq (label notanid) (reg t2) (wconst id-tag))
 
       % ID: Link through function cell
       (*move (reg t6) (reg t3))
       (*wshift (reg t6) 2) % multiply by addressingunitsperfunctioncell
       (*wplus2  (reg t6) (fluid symfnc))
       (ldw (displacement (reg sr0) (reg t6) 0) (reg t3))
       (*wplus2 (reg t1) -8000)
       (ble (displacement (reg sr5) (reg t3) 0))
       (or (reg t1) (reg 0) (reg t2))
 
NOTANID(*jumpnoteq (label notacodepointer) (reg t2) (wconst code-tag))
 
       % Code pointer: jump direct
	(depi 8 4 5 (reg t6))
        (ble (displacement (reg sr5) (reg t6) 0))
        (or (reg 0) (reg 0) (reg 0))

NOTACODEPOINTER
       (*jumpnoteq (label illegalfunctionalform) (reg t2) (wconst pair-tag))
 
       % Pair: make sure it's a lambda, then call FASTLAMBDAPPLY.
 
       (*move (memory (reg t6) (wconst 0)) (reg t2)) % CAR of the inf field.
       (*jumpnoteq (label illegalfunctionalform) (reg t2) 'lambda)
 
       (*move (reg t6) (reg t1))
       (*jcall fastlambdaapply)         % (reg t1) <- lambda function
 
ILLEGALFUNCTIONALFORM
       (*move '"Illegal functional form in Apply" (reg 1))
       (*move (reg t6) (reg 2))
       (*call list2)
       (*jcall stderror)

(*entry fastlambdaapply expr 0)		   % called from FastApply
        (*alloc 1)
        (*move  (Reg t1) (reg ff1))

        (*move (cdr (reg ff1)) (reg ff1))     % get (cdr of lambda form
        (*move (cdr (reg ff1)) (reg ff4))     % save cddr in (reg t1)
	(*wdifference3 (reg ff3) (reg symvalstart) 32000)
        (*move (car (reg ff1)) (reg ff1))     % cadr of lambda form == arg list
					   % in (reg t2)
        (*move (reg r3) (frame 1))  % copy of bndstkptr for restoring
%
%	The first argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
       (ldwx (compl S) (indexed (reg ff2) (reg sr0) (reg ff3)) (reg t6))
	(*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
	(stw (reg t6) (displacement (reg sr0) (reg r3) 0))
        (stw (reg argone) (displacement (reg sr0) (reg ff2) 0))
%
%	The second argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
       (ldwx (compl S) (indexed (reg ff2) (reg sr0) (reg ff3)) (reg t6))
	(*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (stw (reg t6) (displacement (reg sr0) (reg r3) 0))
        (stw (reg argtwo) (displacement (reg sr0) (reg ff2) 0))
%
%	The third argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
       (ldwx (compl S) (indexed (reg ff2) (reg sr0) (reg ff3)) (reg t6))
	(*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (stw (reg t6) (displacement (reg sr0) (reg r3) 0))
        (stw (reg argthree) (displacement (reg sr0) (reg ff2) 0))
%
%	The fourth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
       (ldwx (compl S) (indexed (reg ff2) (reg sr0) (reg ff3)) (reg t6))
	(*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (stw (reg t6) (displacement (reg sr0) (reg r3) 0))
        (stw (reg argfour) (displacement (reg sr0) (reg ff2) 0))
%
%	The fifth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
       (ldwx (compl S) (indexed (reg ff2) (reg sr0) (reg ff3)) (reg t6))
	(*wshift (reg ff2) 2)
	(*wplus2 (reg ff2) (reg ff3))
        (stw (reg t6) (displacement (reg sr0) (reg r3) 0))
        (stw (reg argfive) (displacement (reg sr0) (reg ff2) 0))
%
%	The sixth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 6) (memory (reg ff2) (wconst 0)))
%
%	The seventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 7) (memory (reg ff2) (wconst 0)))
%
%	The eighth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 8) (memory (reg ff2) (wconst 0)))
%
%	The nineth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 9) (memory (reg ff2) (wconst 0)))
%
%	The tenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 10) (memory (reg ff2) (wconst 0)))
%
%	The eleventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 11) (memory (reg ff2) (wconst 0)))
%
%	The twelveth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 12) (memory (reg ff2) (wconst 0)))
%
%	The thirteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 13) (memory (reg ff2) (wconst 0)))
%
%	The fourteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 14) (memory (reg ff2) (wconst 0)))
%
%	The fifteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 15) (memory (reg ff2) (wconst 0)))
%
%	The sixteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (reg ff1) pair-tag)
        (*wplus2 (reg r3) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (reg r3) (reg r5))
        (*move (car (reg ff1)) (reg ff2))
        (*move (cdr (reg ff1)) (reg ff1))
        (*field (reg ff2) (reg ff2) 5 27)	% (reg t5) <- id number
        (*move (reg ff2) (displacement (reg sr0) (reg r3) -4))
        (*wshift (reg ff2) 2)
        (*wplus2 (reg ff2) (reg ff3))
        (*move (memory (reg ff2) (wconst 0)) (memory (reg r3) (wconst 0)))
        (*move (reg 16) (memory (reg ff2) (wconst 0)))

        (*move '"Too many arguments to function" (reg 1))
        (*dealloc 1)
        (*jcall stderror)

BINDINGOVERFLOW
        (*dealloc 1)
        (*jcall bstackoverflow)             % then error

DONEBINDINGFORMALS
        (*move (reg r3) (fluid bndstkptr))  % store binding stack
        (*move (reg ff4) (reg 1))            % get cddr of lambda form to eval
        (*call evprogn)                      % implicit progn
        (*move (reg 1) (reg ff4))            % save result, get old bind stk ptr
        (*move (frame 1) (reg 1))
        (*move (reg ff4) (frame 1))
        (*call restoreenvironment)
        (*move (frame 1) (reg 1))
        (*exit 1)                            % and return

PROPNOTFOUND
	(*move (reg t3) (reg 1))
	(*call unixputn)
	(*call console-newline)
        (*move '"*LAMBDALINK property not found for interpreted function"
               (reg 1))
        (*dealloc 1)
        (*jcall stderror)

))
            
(de lambdaapply (fn args)
  % Fn is Lambda, unevaled Args
  (if (not (and (pairp fn) (weq (car fn) 'lambda)))
    (continuableerror '1104 '"Ill-formed function expression"
                      (cons fn (foreach x in args collect (mkquote x))))
    (prog (formals n result)
          (setq formals (cadr fn))
          (setq n 0)
          (while (and (pairp formals) (pairp args))
            (lbind1 (car formals) (car args))
            (setq formals (cdr formals))
            (setq args (cdr args))
            (setq n (wplus2 n 1)))
          (when (or (pairp formals) (pairp args))
            (return (continuableerror '1204 '"Argument number mismatch"
                     (cons fn (foreach x in args collect (mkquote x))))))
          (setq result (evprogn (cddr fn)))
          (when (wneq n 0)
            (unbindn n))
          (return result))))

(lap '( (*entry list2 expr 2)
	(*alloc 0)
	(addil 16#10000 (reg r10)) % item to reg r1
	(*move (reg r1) (reg t1))
	(stwm (reg 1) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 2) (displacement (reg sr0) (reg r10) 8))
	(stw (reg NIL) (displacement (reg sr0) (reg r10) -4))
	(comb (compl <) (reg r10) (reg r11) (label templabel))
	(*move (reg t1) (reg 1))
	(*savefastframe)  %we are short of heap we have to prepare for gc
	(*call !%reclaim)
	(*restorefastframe)
     templabel
	(*exit 0)))

(lap '( (*entry list3 expr 3)
	(*alloc 0)
	(addil 16#10000 (reg r10)) % item to reg r1
	(*move (reg r1) (reg t1))
	(stwm (reg 1) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 2) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 3) (displacement (reg sr0) (reg r10) 8))
	(stw (reg NIL) (displacement (reg sr0) (reg r10) -4))
	(comb (compl <) (reg r10) (reg r11) (label templabel))
	(*move (reg t1) (reg 1))
	(*savefastframe)  %we are short of heap we have to prepare for gc
	(*call !%reclaim)
	(*restorefastframe)
     templabel
	(*exit 0)))

(lap '( (*entry list4 expr 4)
	(*alloc 0)
	(addil 16#10000 (reg r10)) % item to reg r1
	(*move (reg r1) (reg t1))
	(stwm (reg 1) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 2) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 3) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 4) (displacement (reg sr0) (reg r10) 8))
	(stw (reg NIL) (displacement (reg sr0) (reg r10) -4))
	(comb (compl <) (reg r10) (reg r11) (label templabel))
	(*move (reg t1) (reg 1))
	(*savefastframe)  %we are short of heap we have to prepare for gc
	(*call !%reclaim)
	(*restorefastframe)
     templabel
	(*exit 0)))

(lap '( (*entry list5 expr 5)
	(*alloc 0)
	(addil 16#10000 (reg r10)) % item to reg r1
	(*move (reg r1) (reg t1))
	(stwm (reg 1) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 2) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 3) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 4) (displacement (reg sr0) (reg r10) 8))
	(addil 16#10000 (reg r10)) % item to reg r1
	(stw (reg r1) (displacement (reg sr0) (reg r10) -4))
	(stwm (reg 5) (displacement (reg sr0) (reg r10) 8))
	(stw (reg NIL) (displacement (reg sr0) (reg r10) -4))
	(comb (compl <) (reg r10) (reg r11) (label templabel))
	(*move (reg t1) (reg 1))
	(*savefastframe)  %we are short of heap we have to prepare for gc
	(*call !%reclaim)
	(*restorefastframe)
     templabel
	(*exit 0)))
