%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         sun4-nk-spec.sl
% Title:        misc functions for sparc nonkernel
% Author:       Winfried Neun
% Created:      27 February 1989
% Status:       Experimental
% Mode:         Lisp
% Package:      Kernel
%
% (c) Copyright 1989, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime
  (flag '(halfwordsequal vectorequal wordsequal intern-equal
          bothzero floateqn pairequal fast-wordsequal )
                   'internalfunction))

(lap '((*entry fast-clear  expr 2) % this is for SUN4 only
   %
   % clearing unrooled loop
   %
   % parm 1: source            (will be inf'ed)
   % parm 2: length

      (*alloc 0)
      (andn (reg 1) (reg i5) (reg 1))
      (and (reg 2) 15 (reg 5))   % the remainder mod 16
      (*wshift (reg 2) -4)            % length / 16
      (*move 0 (reg 4))
      (*jumpwleq (label exitlupe) (reg 2) 0)
  lupe
      (*move (reg 4)   (indexed (reg 1) 0))
      (*move (reg 4)   (indexed (reg 1) 4))
      (*move (reg 4)   (indexed (reg 1) 8))
      (*move (reg 4)   (indexed (reg 1) 12))
      (*move (reg 4)   (indexed (reg 1) 16))
      (*move (reg 4)   (indexed (reg 1) 16))
      (*move (reg 4)   (indexed (reg 1) 20))
      (*move (reg 4)   (indexed (reg 1) 24))
      (*move (reg 4)   (indexed (reg 1) 28))
      (*move (reg 4)   (indexed (reg 1) 32))
      (*move (reg 4)   (indexed (reg 1) 36))
      (*move (reg 4)   (indexed (reg 1) 40))
      (*move (reg 4)   (indexed (reg 1) 44))
      (*move (reg 4)   (indexed (reg 1) 48))
      (*move (reg 4)   (indexed (reg 1) 52))
      (*move (reg 4)   (indexed (reg 1) 56))
      (*move (reg 4)   (indexed (reg 1) 60))
      (*wplus2 (reg 2) -1)
      (*wplus2 (reg 1) 64)
      (*jumpwgreaterp (label lupe) (reg 2) 0)
   exitlupe
      (*move 15 (reg 4))
      (*wdifference (reg 4) (reg 5))  % 15 -rem (lng,16)
      (*wshift (reg 4) 2)             % * 2 (4 bytes)
      (move-relocatable-object "Hugo" (reg 5))
      (jmpl (displacement (reg 5) (reg 4)) (reg 0))
      (*move 0 (reg 2))
    "Hugo"
      (*move (reg 2) (indexed (reg 1) 56))
      (*move (reg 2) (indexed (reg 1) 52))
      (*move (reg 2) (indexed (reg 1) 48))
      (*move (reg 2) (indexed (reg 1) 44))
      (*move (reg 2) (indexed (reg 1) 40))
      (*move (reg 2) (indexed (reg 1) 36))
      (*move (reg 2) (indexed (reg 1) 32))
      (*move (reg 2) (indexed (reg 1) 28))
      (*move (reg 2) (indexed (reg 1) 24))
      (*move (reg 2) (indexed (reg 1) 20))
      (*move (reg 2) (indexed (reg 1) 16))
      (*move (reg 2) (indexed (reg 1) 12))
      (*move (reg 2) (indexed (reg 1)  8))
      (*move (reg 2) (indexed (reg 1)  4))
      (*move (reg 2) (indexed (reg 1)  0))
      (*exit 0)))
 
(remd 'eqn)

(de eqn (u v)
  % Eq or numeric equality.
      (case (tag u)
        ((posint-tag)   (or (weq u v) (and (eq 0 u) (bothzero u v))))
        ((negint-tag)   (weq u v))
        ((floatnum-tag) (floateqn u v))
        ((fixnum-tag)
                (and (fixnp v) (weq (fixval (fixinf u)) (fixval (fixinf v)))))
        ((bignum-tag)   (and (bigp v) (wordsequal u v)))
        (nil (eq u v))))

(de floateqn (u v)
      (or (and (floatp v)
               (weq (floathighorder (fltinf u)) (floathighorder (fltinf v)))
               (weq (floatloworder (fltinf u))  (floatloworder (fltinf v))))
          (bothzero u v)))

(de bothzero (u v) (and (zerop u) (zerop v)))

% (remd 'equal)

(commentoutcode de equal (u v)
  % Structural equality
      (case (tag u)
        ((posint-tag)    (or (weq u v) (and (eq u 0) (eqn u v))))
        ((negint-tag code-tag id-tag unbound-tag forward-tag 16 17 18 19)
                         (weq u v))  % to fool &comcase
        ((evector-tag)   (or (weq u v) (evectorequal u v)))
        ((vector-tag)    (and (vectorp v) (vectorequal u v)))
        ((string-tag)    (and (stringp v) (stringequal u v)))
        ((bytes-tag)     (and (bytesp v)  (stringequal u v)))
        ((pair-tag)      (and (pairp v)   (pairequal u v)))
        ((floatnum-tag)  (eqn u v))
        ((fixnum-tag)    (eqn u v))
        ((bignum-tag)    (and (bigp v)    (wordsequal u v)))
        ((words-tag)     (and (wrdsp v)   (wordsequal u v)))
        ((halfwords-tag) (and (halfwordsp v) (halfwordsequal u v)))
        ((hbytes-tag hhalfwords-tag hwords-tag hvect-tag sgd-tag)
          (weq u v)) %just to fool &comcase
        (nil nil)))


(commentoutcode lap '((*ENTRY EQUAL EXPR 2) 
	(SUBCC (REG 1) (REG 2) (REG G0))
	(BNE!,A G4711)
	(SRL (REG 1) 27 (REG 5))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(LD (INDEXED (REG G7) -36) (REG 1))
      G4711
	(SLL (REG 5) 3 (REG T5)) 
	(MOVE-RELOCATABLE-OBJECT "L0003" (REG T1)) 
	(JMPL (DISPLACEMENT (REG T1) (REG T5)) (REG 0)) 
        (MOV (REG 1) (REG 4))
      "L0003" 
	(BA G0058) (SUBCC (REG 4) 0 (REG G0))
	(BA (ENTRY EQN)) (MOV (REG 4) (REG 1)) 
	(BA G0060) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA (ENTRY EQN)) (MOV (REG 4) (REG 1)) 
	(BA G0062) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0063) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0064) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0065) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0066) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0067) (SRL (REG 2) 27 (REG T5))
	(BA (ENTRY EVECTOREQUAL)) (MOV (REG 4) (REG 1))
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
      G0058 
        (BE!,A (ENTRY EQN))
        (MOV (REG 4) (REG 1))
        (JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
        (MOV (REG NIL) (REG 1))
      G0066 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 8 (REG G0)) 
	(BE!,A (INTERNALENTRY VECTOREQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
        (MOV (REG NIL) (REG 1))
      G0062 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 4 (REG G0)) 
	(BE!,A (ENTRY STRINGEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0063 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 5 (REG G0)) 
	(BE!,A (ENTRY STRINGEQUAL))
	(MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1))
      G0067 
	(SUBCC (REG T5) 9 (REG G0)) 
	(BE!,A (INTERNALENTRY PAIREQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0060 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 2 (REG G0)) 
	(BE!,A (INTERNALENTRY WORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0065 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 7 (REG G0)) 
	(BE!,A (INTERNALENTRY WORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0064 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 6 (REG G0)) 
	(BE!,A (INTERNALENTRY HALFWORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0069 
	(SUBCC (REG 4) (REG 2) (REG G0)) 
	(BE!,A G0001) 
	(NOP) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0001 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(NOP)))

(lap '((*ENTRY INTERN-EQUAL EXPR 2)
        (SUBCC (REG 1) (REG 2) (REG G0))
        (BNE!,A G4711)
        (SRL (REG 1) 27 (REG 5))
        (JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
        (LD (INDEXED (REG G7) -36) (REG 1))
      G4711
	(SLL (REG 5) 3 (REG T5)) 
	(MOVE-RELOCATABLE-OBJECT "L0003" (REG T1)) 
	(JMPL (DISPLACEMENT (REG T1) (REG T5)) (REG 0)) 
        (MOV (REG 1) (REG 4))
      "L0003" 
	(BA G0058) (SUBCC (REG 4) 0 (REG G0))
	(BA (ENTRY EQN)) (MOV (REG 4) (REG 1)) 
	(BA G0060) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA (ENTRY EQN)) (MOV (REG 4) (REG 1)) 
	(BA G0062) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0063) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0064) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0065) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0066) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0067) (SRL (REG 2) 27 (REG T5))
	(BA (ENTRY EVECTOREQUAL)) (MOV (REG 4) (REG 1))
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(BA G0069) (LD (INDEXED (REG G7) -36) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(BA G0001) (MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))(MOV (REG NIL) (REG 1)) 
      G0058 
	(BE!,A (ENTRY EQN))
        (MOV (REG 4) (REG 1)) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0070 
	(BE!,A G0001) 
	(LD (INDEXED (REG G7) -36) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0066 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 8 (REG G0)) 
	(BE!,A (INTERNALENTRY VECTOREQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
        (MOV (REG NIL) (REG 1))
      G0062 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 4 (REG G0)) 
	(BE!,A (ENTRY STRINGEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0063 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 5 (REG G0)) 
	(BE!,A (ENTRY STRINGEQUAL))
	(MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1))
      G0067 
	(SUBCC (REG T5) 9 (REG G0)) 
	(BE!,A (INTERNALENTRY PAIREQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0060 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 2 (REG G0)) 
	(BE!,A (INTERNALENTRY WORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0065 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 7 (REG G0)) 
	(BE!,A (INTERNALENTRY WORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0064 
	(SRL (REG 2) 27 (REG T5)) 
	(SUBCC (REG T5) 6 (REG G0)) 
	(BE!,A (INTERNALENTRY HALFWORDSEQUAL))
        (MOV (REG 4) (REG 1))
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0))
	(MOV (REG NIL) (REG 1)) 
      G0069 
	(SUBCC (REG 4) (REG 2) (REG G0)) 
	(BE!,A G0001) 
	(NOP) 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(MOV (REG NIL) (REG 1)) 
      G0001 
	(JMPL (DISPLACEMENT (REG 15) 8) (REG 0)) 
	(NOP)))

(de pairequal (u v)
     (cond ((eq u v) t)
           ((intern-equal (car u) (car v)) (intern-equal (cdr u) (cdr v)))
           (T nil)))
 
(remd 'wordsequal)

(de wordsequal (u v)
  (prog (s1 i)
        (setq u (wrdinf u))
        (setq v (wrdinf v))
        (unless (weq (setq s1 (wrdlen u)) (wrdlen v)) (return nil))
%       (setq i 0)
%  loop
%       (when (wgreaterp i s1)    (return t))
%       (unless (weq (wrditm u i) (wrditm v i))  (return nil))
%       (setq i (wplus2 i 1))
%       (go loop)))
        (return (fast-wordsequal u v s1))))

(remd 'halfwordsequal)

(de halfwordsequal (u v)
  (prog (s1 i)
        (setq u (halfwordinf u))
        (setq v (halfwordinf v))
        (unless (wgreaterp (setq s1 (halfwordlen u)) (halfwordlen v))
          (return nil))
        (setq i 0)
   loop
        (when (wgreaterp i s1)        (return t))
        (unless (weq (halfworditm u i) (halfworditm v i)) (return nil))
        (setq i (wplus2 i 1))
        (go loop)))


(remd 'vectorequal)

(de vectorequal (u v)
  % Vector equality without type check
  (prog (len i)
        (setq u (vecinf u))
        (setq v (vecinf v))
        (setq len (veclen u))
        (when (wneq len (veclen v))  (return nil))
        (setq i 0)
   loop
        (when (wgreaterp i len)      (return t))
        (unless (equal (vecitm u i) (vecitm v i))       (return nil))
        (setq i (wplus2 i 1))
        (go loop)))

(lap '((*entry fast-wordsequal expr 3)

       % specially coded to be alloc-free
       % Arg1, Arg2 addresses of vectors to compare
       % length is eq for both args

     lupe
       (*move (indexed (reg 1) 4) (reg 4)) % wrdsitm access!
       (*move (indexed (reg 2) 4) (reg 5))
       (add (reg 1) 4 (reg 1))
       (subcc (reg 4) (reg 5) (reg g0))
       (bne noteq)
       (subcc (reg 3) 1 (reg 3))
       (bge lupe)
       (add (reg 2) 4 (reg 2))

       (jmpl (indexed (reg o7) 8) (reg g0))  % its eq
       (*move (quote t) (reg 1))
     noteq
       (jmpl (indexed (reg o7) 8) (reg g0))
       (*move (reg nil) (reg 1))))

(remd 'evlis)

(de evlis(u)
      (prog (result pointer)
           (when (not (pairp u)) (return nil))
           (setq pointer (setq result (cons (eval (car u)) nil)))
       loop
           (setq u (cdr u))
           (when (not (pairp u)) (return result))
           (rplacd pointer (cons (eval (car u)) nil))
           (setq pointer (cdr pointer))
           (go loop)))

(mapobl 
  (function 
    (lambda (id)
	(when (get id 'type) 
	 (if (wgetv SYMGET (idinf id))
		(wputv (inf (wgetv SYMGET (idinf id))) 1 (get id 'type))
		 (wputv SYMGET (idinf id) (mkvect &symgetsize&))
		 (wputv (inf (wgetv SYMGET (idinf id))) 1 (get id 'type)) )))))
