%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         FLOATS.SL
% Title:        Floating-Point operations for CRAY 1
% Author:       W. Neun, ZIB Berlin
% Created:      18 Januar 1986
% Status:       Experimental
% Mode:         Lisp
% Package:      NonKernel (Cray)
%
% Copyright (c) 1987, Konrad Zuse-Zentrum Berlin, all rights reserved
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(lap '((*entry *Fquotient expr 3)
       (*alloc 0)
       (*move (reg 3) (reg a6))
       (*move (memory (reg a6) 0) (reg 3))
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 1) (reg s6))
       (*move (reg 1) (reg a6))
       (hrecip (reg 1) (reg 3))
       (fmul  (reg 2) (reg 2) (reg 1))
       (imul  (reg 3) (reg 3) (reg 1))
       (fmul  (reg 2) (reg 2) (reg 3))
       (*move (reg 2) (memory (reg a6) 0))
       (*move (reg s6) (reg 1))
       (*exit 0)
)     )
 
(lap '((*entry *Fplus2 expr 3)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 3) (reg a6))
       (*move (memory (reg a6) 0) (reg 3))
       (*move (reg 1) (reg a6))
       (fadd (reg 2) (reg 2) (reg 3))
       (*move (reg 2) (memory (reg a6) 0))
       (j (reg b00))
)     )
 
(lap '((*entry *Fdifference  expr 3)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 3) (reg a6))
       (*move (memory (reg a6) 0) (reg 3))
       (*move (reg 1) (reg a6))
       (fsub (reg 2) (reg 2) (reg 3))
       (*move (reg 2) (memory (reg a6) 0))
       (j (reg b00))
)     )
 
(lap '((*entry *Ftimes2 expr 3)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 3) (reg a6))
       (*move (memory (reg a6) 0) (reg 3))
       (*move (reg 1) (reg a6))
       (rmul (reg 2) (reg 2) (reg 3))
       (*move (reg 2) (memory (reg a6) 0))
       (j (reg b00))
)     )
 
(lap '((*entry *Fassign expr 2)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 1) (reg a6))
       (*move (reg 2) (memory (reg a6) 0))
       (j (reg b00))
)     )
 
(lap '((*entry *Wfloat  expr 2)
       (*alloc 0)
       (*move (reg 1) (reg a6))
       (*move (reg 1) (reg s6))
       (sconst06 (reg 1))
       (sub (reg 2) (reg 1) (reg 2))
       (fsub (reg 2) (reg 1) (reg 2))
       (*move (reg 2) (memory (reg a6) 0))
       (*move (reg s6) (reg 1))
       (*exit 0)
)     )
 
(lap '((*entry *Wfix  expr 1)
       (*alloc 0)
       (*move (reg 1) (reg a6))
       (*move (memory (reg a6) 0) (reg 1))
       (*move (reg 2) (reg s6))
       (sconst06 (reg 2))
       (fsub (reg 1) (reg 2) (reg 1))
       (sub (reg 1) (reg 2) (reg 1))
       (*move (reg s6) (reg 2))
       (*exit 0)
)     )
%
(lap '((*entry *Fgreaterp expr 2)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 1) (reg a6))
       (*move (memory (reg a6) 0) (reg 1))
       (fsub (reg s0) (reg 2) (reg 1))
       (jsm greater)
       (*move (QUOTE nil) (reg 1))
       (j (reg b00))
     greater
       (*move (QUOTE t) (reg 1))
       (j (reg b00))
)     )
 
(lap '((*entry *Flessp expr 2)
       (*move (reg 2) (reg a6))
       (*move (memory (reg a6) 0) (reg 2))
       (*move (reg 1) (reg a6))
       (*move (memory (reg a6) 0) (reg 1))
       (fsub (reg s0) (reg 1) (reg 2))
       (jsp greater1)
       (*move (QUOTE t) (reg 1))
       (j (reg b00))
     greater1
       (*move (QUOTE nil) (reg 1))
       (j (reg b00))
)     )
