%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:DUMPLISP.SL
% Description:  Dump running lisp to an binary loadable file.
% Author:       W. Neun
% Created:      27-Feb-90
% Modified:
% Package:
%
% (c) Copyright 1990, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  28-Nov-90 (HM): increased magic by 1 to 4713 for WINDOWS mode 
 
(fluid '(gctime* gcknt*))
 
(global '(nextbps heaplast heapupperbound stacklowerbound))
 
(de dumplisp (filename)
  (prog (fil savedstacklowerbound unexecresult savedunixargs)
	(unless (stringp filename)
	  (stderror "Dumplisp requires a filename argument"))
	(compactheap)
	(setq gctime* 0 gcknt* 0)
	(setq fil (binaryopenwrite filename))
	(binarywrite fil 4713) %magic 
	(binarywrite fil heaplast)
	(binarywrite fil nextbps)
	(binarywrite fil lastbps)
	(binarywrite fil (difference heaplast lastbps))
	(binarywrite fil (wplus2 heapupperbound 4))
	(binarywrite fil (inf (cdr (getd '!m!a!i!n))))
	(binarywriteblock fil 0 (wshift (wplus2 4 nextbps) -2))
	(binarywriteblock fil lastbps 
	     (wshift (wplus2 4 (wdifference heaplast lastbps)) -2))
	(binaryclose fil)))

(de getheap () nil)
%% End of File.
 
 
 
